<template>
    <div class="flex flex-col h-full justify-end w-full md:w-132 lg:w-144 overflow-y-auto" v-show="visibility">
        <div v-if="editable && importing" class="bg-white">
            <wee-spatial-report-importer :cancel="cancel" :project="project"></wee-spatial-report-importer>
        </div>
        <div class="overflow-x-auto bg-white flex-grow">
            <div class="w-full min-w-full h-full overflow-hidden">
                <table class="relative w-full h-full flex flex-col">
                    <thead>
                    <tr class="flex flex-row h-full items-center">
                        <th class="px-2 py-2 border-b border-gray-200 bg-gray-50 text-left text-xs leading-4 font-medium text-gray-500 uppercase tracking-wider">Id</th>
                        <th class="px-2 py-2 border-b border-gray-200 bg-gray-50 text-left text-xs leading-4 font-medium text-gray-500 uppercase tracking-wider flex flex-row flex-grow" v-if="columns.includes('Area')">
                            <button class="text-gray-500 hover:text-gray-700 bg-transparent font-bold px-1 rounded" v-on:click="load()">
                                <img svg-inline src="./pix/zond/reload.svg" alt="" class="w-6 h-6 fill-current" />
                            </button>
                            <v-select v-model="page" label="label" :options="pages" :reduce="page => page.value" class="w-full bg-gray-100 mr-2 ml-2" :clearable="false" :searchable="false"></v-select>
                            <button class="text-gray-500 hover:text-gray-700 bg-transparent font-bold px-1 rounded" v-on:click="prev()">
                                <img svg-inline src="./pix/zond/backward.svg" alt="" class="w-6 h-6 fill-current" />
                            </button>
                            <button class="text-gray-500 hover:text-gray-700 bg-transparent font-bold px-1 rounded" v-on:click="next()">
                                <img svg-inline src="./pix/zond/forward.svg" alt="" class="w-6 h-6 fill-current" />
                            </button>
                        </th>
                        <th class="px-2 py-2 border-b border-gray-200 bg-gray-50 text-left text-xs leading-4 font-medium text-gray-500 uppercase tracking-wider" v-if="columns.includes('Time')">Time</th>
                        <th class="px-2 py-2 border-b border-gray-200 bg-gray-50 text-left text-xs leading-4 font-medium text-gray-500 uppercase tracking-wider flex flex-row justify-end">
                            <button v-if="editable" class="bg-transparent font-bold px-1 rounded float-right" v-on:click="createReport()" :class="[palette().regular.text, palette().darker.hover]">
                                <img svg-inline src="./pix/zond/add-outline.svg" class="w-6 h-6 fill-current" />
                            </button>
                            <button v-if="editable" class="bg-transparent font-bold px-1 rounded float-right" v-on:click="importReports()" :class="[palette().regular.text, palette().darker.hover]">
                                <img svg-inline src="./pix/zond/upload.svg" class="w-6 h-6 fill-current" />
                            </button>
                            <button class="bg-transparent font-bold px-1 rounded float-right" v-on:click="close()" :class="[palette().regular.text, palette().darker.hover]">
                                <img svg-inline src="./pix/zond/close-solid.svg" class="w-6 h-6 fill-current" />
                            </button>
                        </th>
                    </tr>
                    </thead>
                    <tbody class="bg-white overflow-y-auto w-full">
                        <tr class="flex flex-row w-full" v-for="report in reports" :key="report.id" v-bind:class="{'bg-pink-100': !report.places && (!selectedReport || (selectedReport.id != report.id)), 'bg-yellow-200': selectedReport && (selectedReport.id == report.id), 'hover:bg-gray-100': !selectedReport || (selectedReport.id != report.id)}">
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <div class="flex flex-col items-center content-center">
                                    <div class="flex-shrink-0 h-10 w-10">
                                        <img svg-inline src="./pix/virus-green.svg" class="w-full h-full" />
                                    </div>
                                    <div class="px-2 rounded-full mt-2" :class="[reportPalette(report.type.id).darkish.bg, reportPalette(report.type.id).lighter.text]">
                                        <span class="text-xs">{{report.id}}</span>
                                    </div>
                                </div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap flex-grow w-full overflow-x-hidden">
                                <div class="text-sm leading-5 text-gray-900 whitespace-pre-line w-full">{{report.aoi.replace(/\$\d+\s*/, '')}}</div>
                                <ul class="">
                                    <li class="list-none float-left mr-1 w-auto mt-1" v-for="(value, key) in report.properties" :key="key" v-if="value.length && !ignored.includes(key)">
                                        <div class="tag text-xs inline-block flex flex-row" :class="[reportPalette(report.type.id).darker.text]">
                                            <span class="key px-2 rounded-l-full capitalize" :class="[reportPalette(report.type.id).regular.bg, reportPalette(report.type.id).lighter.text]">{{key}}</span>
                                            <span class="value px-2 -ml-1 rounded-r-full truncate flex-grow max-w-xs" :class="[reportPalette(report.type.id).light.bg]" v-html="value" v-linkified></span>
                                        </div>
                                    </li>
                                </ul>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap" v-if="columns.includes('Time')">
                                <div class="text-sm leading-5 text-gray-900" v-tooltip="'Time of Interest'">{{report.toi}}</div>
                                <div class="text-xs leading-5 text-gray-500" v-tooltip="'Created'">{{report.created}}</div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap text-sm leading-5 text-gray-500">
                                <button v-if="editable" class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="edit(report)" :class="[reportPalette(report.type.id).lightest.bg, reportPalette(report.type.id).regular.text, reportPalette(report.type.id).darker.hover]">
                                    <img svg-inline src="./pix/zond/edit-pencil.svg" class="w-4 h-4 fill-current" />
                                </button>
                                <button class="font-bold py-1 px-2 rounded inline-flex items-center rounded-l-lg rounded-r-lg" v-on:click="locate(report)" :class="[reportPalette(report.type.id).lightest.bg, reportPalette(report.type.id).regular.text, reportPalette(report.type.id).darker.hover]">
                                    <img svg-inline src="./pix/zond/location.svg" class="w-5 h-5 fill-current mt-1 mr-1" />
                                    <span class="inline-block text-xs"  :class="[reportPalette(report.type.id).dark.text]">{{report.places}}</span>
                                </button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <div v-if="editable" v-show="((editing || locating) && selectedReport)" class="flex flex-col w-full max-h-full">
            <wee-spatial-similar-reports-viewer ref="similarityViewer" :report="selectedReport" :project="project" :theme="theme"></wee-spatial-similar-reports-viewer>
        </div>
        <div v-if="editable" v-show="(editing && selectedReport) || creating" class="flex flex-col w-full max-h-full">
            <wee-spatial-report-editor :report="selectedReport" :project="project" :cancel="cancel" v-on:added="reload()" v-on:updated="reload()" v-on:removed="reload()" :theme="theme" :universe="universe" :common="common"></wee-spatial-report-editor>
        </div>
        <div v-show="(locating && selectedReport)" class="flex flex-col w-full max-h-full">
            <wee-spatial-location-editor :editable="editable" :report="selectedReport" :cancel="cancel" ref="locator" v-on:go="go" v-on:search="search" v-on:capture="capture" v-on:hide="hide" v-on:placed="placed" v-on:replaced="replaced" v-on:deplaced="deplaced" :theme="theme"></wee-spatial-location-editor>
        </div>
    </div>
</template>
<script>
    import Vue from 'vue'
    import vSelect from 'vue-select'
    import axios from 'axios'
    import axiosCancel from 'axios-cancel';
    import VCalendar from 'v-calendar';
    import VTooltip from 'v-tooltip'
    import WeeSpatialReportImporter from './WeeSpatialReportImporter'
    import WeeSpatialReportEditor from './WeeSpatialReportEditor'
    import WeeSpatialLocationEditor from './WeeSpatialLocationEditor'
    import WeeSpatialSimilarReportsViewer from './WeeSpatialSimilarReportsViewer'
    import linkify from 'vue-linkify';
    import {ThemeMixin} from './themes.js';
    import './style.css';
    
    const DB_WB_DISTRICTS =  [{"value":"AD","label":"Alipurduar"},{"value":"BN","label":"Bankura"},{"value":"BR","label":"Paschim Bardhaman"},{"value":"BR","label":"Purba Bardhaman"},{"value":"BI","label":"Birbhum"},{"value":"KB","label":"Cooch Behar"},{"value":"DA","label":"Darjeeling"},{"value":"UD","label":"Uttar Dinajpur"},{"value":"DD","label":"Dakshin Dinajpur"},{"value":"HG","label":"Hooghly"},{"value":"HR","label":"Howrah"},{"value":"JP","label":"Jalpaiguri"},{"value":"JH","label":"Jhargram"},{"value":"KO","label":"Kolkata"},{"value":"KA","label":"Kalimpong"},{"value":"MA","label":"Malda"},{"value":"ME","label":"Paschim Medinipur"},{"value":"ME","label":"Purba Medinipur"},{"value":"MU","label":"Murshidabad"},{"value":"NA","label":"Nadia"},{"value":"PN","label":"North 24 Parganas"},{"value":"PS","label":"South 24 Parganas"},{"value":"PU","label":"Purulia"}];;
    
    Vue.component('v-select', vSelect);
    Vue.use(VCalendar);
    Vue.use(VTooltip);
    Vue.directive('linkified', linkify);

    axiosCancel(axios, {
        debug: false // default
    });

    export default {
        name: "WeeSpatialReportBrowser",
        props: {
            editable: {
                type: Boolean,
                default: false
            },
            project: {
                type: Number,
                required: true
            },
            type: {
                type: Number,
                required: true
            },
            limit: {
                type: Number,
                default: 20
            },
            ignored: {
                type: Object,
                default: ['country', 'state']
            },
            columns: {
                type: Array,
                default: ['Area']
            },
            theme: {
                type: Object
            },
            universe: {
                type: Array,
                default: []
            },
            common: {
                type: Array,
                default: []
            }
        },
        mixins: [ThemeMixin],
        data: function(){
            return {
                visibility: 1,
                count: 0,
                page: 0,
                selectedReport: null,
                creating: false,
                editing:  false,
                locating: false,
                importing: false,
                similarity: false,
                reports: []
            }
        },
        components: {
            WeeSpatialReportImporter,
            WeeSpatialReportEditor,
            WeeSpatialLocationEditor,
            WeeSpatialSimilarReportsViewer
        },
        created(){
            let self = this;
            axios.post(this.reportsCount).then(function(response){
                self.count = response.data.count;
                self.load();
            });
        },
        watch: {
            page: function(n, o){
                const last = this.pages.slice(-1).pop().value;
                if(n >= 0 && n <= last){
                    this.page = n;
                    this.load();
                }else if(n < 0){
                    this.page = 0;
                }else if(n > last){
                    this.page = last;
                }
            }
        },
        methods: {
            selected(selection){
                this.$refs.locator.selected(selection);
            },
            load(){
                let self = this;
                axios.get(this.pageUrl).then(function(response){
                    self.reports = response.data.reports;
                    if(response.data.count > 0){
                        self.offset += self.limit;
                    }
                }).catch(function(error){
                    console.log(error);
                });
            },
            reload(){
                this.load();
            },
            next(){
                this.page += this.limit;
            },
            prev(){
                this.page -= this.limit;
            },
            createReport(){
                this.resetState();
                this.creating = true;
            },
            resetState(){
                this.selectedReport = null;
                this.creating = false;
                this.editing  = false;
                this.locating = false;
                this.importing = false;
            },
            edit(report){
                this.resetState();
                this.selectedReport = report;
                this.editing = true;
            },
            locate(report){
                this.resetState();
                this.selectedReport = report;
                this.locating = true;
            },
            importReports(){
                this.resetState();
                this.importing = true;
            },
            cancel(){
                this.resetState();
            },
            go(coordinate){
                this.$emit('go', coordinate);
                this.$emit('explore', true);
            },
            search(place){
                this.$emit('search', place);
                this.$emit('explore', true);
            },
            capture(mode, id){
                this.$emit('capture', mode, id);
            },
            captured(){
                this.$refs.locator.captured();
            },
            hide(flag){
                this.visibility = !flag;
            },
            placed(id, report){
                console.log('ReportBrowser::placed', id, report);
                this.$emit('placed', id);
                this.updateReport(report);
            },
            replaced(id, report){
                console.log('ReportBrowser::placed', id, report);
                this.$emit('replaced', id);
            },
            deplaced(id, report){
                console.log('ReportBrowser::deplaced', id, report);
                this.$emit('deplaced', id);
                this.updateReport(report);
            },
            updateReport(id){
                for(const i in this.reports){
                    const report = this.reports[i];
                    if(report.id == id){
                        let self = this;
                        axios.get(this.reportUrl).then(function(response){
                            if(response.data.report){
                                self.$set(self.reports, i, response.data.report);
                            }
                        }).catch(function(error){
                            console.log(error);
                        });
                    }
                }
            },
            close(){
                this.$emit('close');
            }
        },
        computed: {
            pages: function(){
                let self = this;
                let p = [...Array(Math.floor(this.count / this.limit)).keys()];
                if(!p.length){
                    p.unshift(0);
                }
                const l = p.map(function(i){
                    return {
                        value: i * self.limit,
                        label: (i * self.limit) + ' ... ' + ((i+1) * self.limit)
                    };
                });
                return l;
            },
            pageUrl: function(){
                const offset = this.page;
                if(this.type){
                    return '/reports/fetch/'+this.project+'/'+this.type+'/'+offset+'/'+this.limit;
                }else{
                    return '/reports/fetch/'+this.project+'/'+offset+'/'+this.limit;
                }
            },
            reportsCount: function(){
                return '/reports/count/'+this.project+'/'+(this.type ? this.type : '');
            },
            reportUrl: function(){
                return '/reports/'+this.selectedReport.id;
            }
        }
    }
</script>
<style scoped>
::-webkit-scrollbar {
  width: 6px;
  height: 6px;
}
::-webkit-scrollbar-button {
  width: 0px;
  height: 0px;
}
::-webkit-scrollbar-thumb {
  background: #525252;
  border: 0px none #ffffff;
  border-radius: 50px;
}
::-webkit-scrollbar-thumb:hover {
  background: #666666;
}
::-webkit-scrollbar-thumb:active {
  background: #313131;
}
::-webkit-scrollbar-track {
  background: #adadad;
  border: 0px none #ffffff;
  border-radius: 55px;
}
::-webkit-scrollbar-track:hover {
  background: #adadad;
}
::-webkit-scrollbar-track:active {
  background: #adadad;
}
::-webkit-scrollbar-corner {
  background: transparent;
}
</style>
